package de.donmanfred;

//import java.util.List;
//import java.util.Set;

import java.util.ArrayList;
import java.util.Set;

import eu.coges.btdatakeymodule.BTDataKeyModule;
import eu.coges.btdatakeymodule.BTDataKeyModuleIface;
import eu.coges.btdatakeymodule.Wrapper.BluetoothLeService;
import android.app.AlertDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothAdapter.LeScanCallback;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothGattCharacteristic;
import android.bluetooth.BluetoothGattDescriptor;
import android.bluetooth.BluetoothGattServerCallback;
import android.bluetooth.BluetoothGattService;
import android.bluetooth.BluetoothManager;
import android.bluetooth.le.BluetoothLeScanner;
import android.bluetooth.le.ScanCallback;
import android.bluetooth.le.ScanFilter;
import android.bluetooth.le.ScanResult;
import android.bluetooth.le.ScanSettings;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.location.LocationManager;
import android.os.Build;
import android.os.Handler;
import android.os.ParcelUuid;
import android.preference.PreferenceManager;
import anywheresoftware.b4a.AbsObjectWrapper;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.IOnActivityResult;
import anywheresoftware.b4a.objects.collections.*;

// TODO Version
@Version(1.08f)
@ShortName("Coges")
@Author(value = "DonManfred (wrapper)")
//@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE"})
@Events(values={
		"onLeScan(device as Bluetoothdevice, index As int, raw as byte[])",
		"onScanResult(device as Bluetoothdevice, scanType As int, raw as byte[])",
		"onBTDataKeyPendingStatusReceived(datapending As boolean)",
		"onBTDataKeyPacketReceived(messageCounter As int, message As String)",
		"onBTDataKeyBatteryLevelReceived(battLevel As int)",
		"onBTDataKeyOpCodeConfigurationSuccess()",
		"onBTDataKeyDeleteSuccess()",
		"onBTDataKeyAuditReceived(raw As byte[], dataKeyMode AsString, auditText AsString, auditPath As String)",
		"onBTDataKeyError(errorCode As int, errormessage As String)",
		"onBTDataKeyModuleError(errorCode As int, errormessage As String)",
		"onBTDataKeyStatusChanged(status As int)"
})
@DependsOn(values={"btdatakeymodule-v1.0.7.aar","com.android.support:appcompat-v7","com.android.support:recyclerview-v7"})

/**
 * com.android.support:support-v4
 * com.android.support:appcompat-v7
 * com.android.support:cardview-v7
 * com.android.support:gridlayout-v7
 * com.android.support:mediarouter-v7
 * com.android.support:palette-v7
 * com.android.support:recyclerview-v
 * com.android.support:preference-v7
 * com.android.support:support-v13
 */

public class BTDataKeyModuleWrapper extends AbsObjectWrapper<BTDataKeyModule>  {
	private BA ba;
	private String eventName;
	private IOnActivityResult ion;
	
  public static final String EXTRAS_DEVICE_NAME = "DEVICE_NAME";
  public static final String EXTRAS_DEVICE_ADDRESS = "DEVICE_ADDRESS";

  public static final String EXTRAS_INTENT_ACTION = "INTENT_ACTION";
  public static final String EXTRAS_INTENT_SUBACTION = "INTENT_SUBACTION";
  public static final String EXTRAS_DEVICECONTROL_ACTION = "Device Control";

  public static final String EXTRAS_OPCODE_ACTION = "Set Operator code";
  public static final String EXTRAS_GETDATA_ACTION = "Get Data";

  private BluetoothLeScanner mBluetoothLeScanner = null;
  private ScanCallback mScanCallback = null;
  private boolean mScanning;
  private Handler mHandler;

  private String mDevAddr = null;
  private boolean mDevAddrFound = false;
  private boolean mStarted = false;

  // Device scan callback.
  private BluetoothAdapter.LeScanCallback mLeScanCallback =
      new BluetoothAdapter.LeScanCallback() {

          @Override
          public void onLeScan(final BluetoothDevice device, int rssi, byte[] scanRecord) {
          
          }
      };

  
  
  
  
  // TO TEST BTDataKeyModule
  private BluetoothDevice mDevice;
  private boolean isJustInited = true;
  private BTDataKeyModule mBTDataKeyModule = new BTDataKeyModule();
  // END of TEST BTDataKeyModule

  private int mMessageCounter = 0;	
	private BluetoothLeScanner scanner;
	private ScanCallback scancb;
	private static final int REQUEST_ENABLE_BT = 1;
  private static final int REQUEST_ENABLE_LM = 2;
  private static final int REQUEST_ENABLE_COARSE_LOCATION = 3;
  private static final int REQUEST_ENABLE_STORAGE = 4;

  public static final int ERR_BTDK_NONE = 0;
  public static final int ERR_BTDK_ILLEGAL_STATUS = 1;
  public static final int ERR_BTDK_NOT_RESPONDING = 2;
  public static final int ERR_BTDK_DATA_REC_TIMEOUT = 3;
  public static final int ERR_BTDK_UNLOCKED = 4;
  public static final int ERR_BTDK_OPCODE_SIZE = 5;
  public static final int ERR_BTDK_OPCODE_FORMAT = 6;
  public static final int ERR_BTDK_OPCODE_UNLOCK_FAIL = 7;
  public static final int ERR_BTDK_OPCODE = 8;
  public static final int ERR_BTDK_IRCODE = 9;
  public static final int ERR_BTDK_SERVICE_FAILED = 10;
  public static final int ERR_NONE = 0;
  public static final int ERR_BLE_CONNECTION = 1;
  public static final int ERR_EVA_DATA_WRITE = 2;
  public static final int ERR_INTERRUPTED_PROCESS = 3;
  public static final int ERR_NOPATH = 4;
  public static final int S_NO_INIT = 0;
  public static final int S_READY = 1;
  public static final int S_BUSY = 2;
  public static final int S_CONNECTED = 3;
  public static final int S_DISCONNECTED = 4;
  public static final int S_BUSY_COLLECTING = 5;
  public static final int S_BUSY_OPCODE = 6;
  public static final int S_BUSY_UNIQUE = 7;
  public static final int S_BUSY_BATT = 8;
  public static final int S_BUSY_DELETING = 9;
  public static final int S_BUSY_PENDING = 10;
  private SharedPreferences mSharedPreferences = null;
  private BluetoothAdapter mBluetoothAdapter = null;
  private BluetoothManager mBluetoothManager = null;
  private LocationManager mLocationManager = null;

  private Intent enableBtIntent = null;
  private int BtIntentRequest = -1;
  
  // Stops scanning after 10 seconds.
  private static final long SCAN_PERIOD       = 10000;
  private static final long SHORT_SCAN_PERIOD = 5000;

	public void Initialize(final BA ba, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		enableBtIntent = null;
    mSharedPreferences = PreferenceManager.getDefaultSharedPreferences(ba.context);

    final BluetoothManager mBluetoothManager = (BluetoothManager) ba.context.getSystemService(Context.BLUETOOTH_SERVICE);
    if (mBluetoothManager == null) {
    	BA.Log("BT-Manager = null (failed)");
    } else {
    	BA.Log("BT-Manager != null (OK)");
    } 
    mBluetoothAdapter = mBluetoothManager.getAdapter();
    // Checks if Bluetooth is supported on the device.
    if (mBluetoothAdapter == null) {
    	BA.Log("BT-Adapter = null (failed)");
    } else {
    	BA.Log("BT-Adapter != null (OK). Trying to enable");
    	
    	//mBluetoothAdapter
    	
    	mBluetoothAdapter.enable();
    	if (!mBluetoothAdapter.isEnabled()) {
        enableBtIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
        BtIntentRequest = REQUEST_ENABLE_BT;
        BA.Log("BTEnableItent created");
      } else {
      	BA.Log("BTAdapter is enabled...");
      }
    	scanner = mBluetoothAdapter.getBluetoothLeScanner();
  		if (scanner == null){
      	BA.Log("BT-LE-Scanner = null (failed)");
      } else {
      	BA.Log("BT-LE-Scanner != null (OK)");
  		}
  		
  		
//      if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
//      	ArrayList<ScanFilter> scanFiltList = new ArrayList<>();
//        scanFiltList.add(new ScanFilter.Builder().setServiceUuid(new ParcelUuid(BluetoothLeService.a)).build());
//        ScanSettings scanSettings = new ScanSettings.Builder().setScanMode(ScanSettings.SCAN_MODE_LOW_LATENCY).build();
//        
//        //mBluetoothLeScanner.startScan(scanFiltList, scanSettings, mScanCallback);
//        scanner.startScan(mScanCallback);
//      } else {
//      	mBluetoothAdapter.startLeScan(mLeScanCallback);
//      }

    } 
    mHandler = new Handler();
    mStarted = false;
//    scancb = new ScanCallback(){
//			@Override
//			public void onScanResult(int callbackType, ScanResult result) {
//				BA.Log("onScanResult");
//				BluetoothDevice device = result.getDevice();
//				
//			}
//			public void onBatchScanResults(List results) {
//				BA.Log("onBatchScanResults");
//				
//			}
//			@Override
//			public void onScanFailed(int errorCode) { 
//				BA.Log("onScanFailed");
//				
//			}
//
//		};

    
		final BTDataKeyModule _obj = new BTDataKeyModule();
		final String eventName = EventName.toLowerCase(BA.cul);
		setObject(_obj);
		
		
		mScanCallback = new ScanCallback(){
			@Override
			public void onScanResult(int callbackType, ScanResult result) {
				BA.Log("onScanResult 1 Device");
				BluetoothDevice device = result.getDevice();
	 			if (ba.subExists(eventName + "_onscanresult")) {
  				BA.Log("lib:Raising.. "+eventName + "_onscanresult()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onscanresult", true, new Object[] {AbsObjectWrapper.ConvertToWrapper(new BluetoothDeviceWrapper(), device), callbackType, null});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_onscanresult");
  			}
				
			}
			public void onBatchScanResults(List results) {
				BA.Log("onBatchScanResults "+results.getSize()+" devices");
				for (int i = 0; i < results.getSize(); i++) {
					BluetoothDevice device = (BluetoothDevice) results.Get(i);
				}
			}
			@Override
			public void onScanFailed(int errorCode) { 
				BA.Log("onScanFailed");
				
			}
		};
		
		getObject().init(ba.context, new BTDataKeyModuleIface(){

	    @Override
	    public void onBTDataKeyPendingStatusReceived(boolean isDataPending) {
	 			if (ba.subExists(eventName + "_onbtdatakeypendingstatusreceived")) {
  				BA.Log("lib:Raising.. "+eventName + "_onbtdatakeypendingstatusreceived()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onbtdatakeypendingstatusreceived", true, new Object[] {isDataPending});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_onbtdatakeypendingstatusreceived");
  			}
	    }

	    @Override
	    public void onBTDataKeyDataPacketReceived(int messageCounter, String message) {
	    	if (ba.subExists(eventName + "_onbtdatakeypacketreceived")) {
	    		BA.Log("lib:Raising.. "+eventName + "_onbtdatakeypacketreceived()");								
	    		//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
	    		ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onbtdatakeypacketreceived", true, new Object[] {messageCounter, message});
	    	}else {
	    		BA.Log("lib: NOTFOUND '"+eventName + "_onbtdatakeypacketreceived");
	    	}
	    }

	    @Override
	    public void onBTDataKeyBatteryLevelReceived(int battLevel) {
	    	if (ba.subExists(eventName + "_onbtdatakeybatterylevelreceived")) {
	    		BA.Log("lib:Raising.. "+eventName + "_onbtdatakeybatterylevelreceived()");								
	    		//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
	    		ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onbtdatakeybatterylevelreceived", true, new Object[] {battLevel});
	    	}else {
	    		BA.Log("lib: NOTFOUND '"+eventName + "_onbtdatakeybatterylevelreceived");
	    	}
	    	/*mBTDataKeyModule.setBTDataKeyOperatorCode("00000000","00000000");*/

	        /* Uncomment the line below in order to check the pending status of the Key */
	        //mBTDataKeyModule.getBTDataKeyPendingStatus();

	        //mMessageCounter = 0;    // Reset data message counter
	        //byte passwordIRDA[] = null; /*new byte[]{0x11,0x11,0x11,0x11};*/
	        //mBTDataKeyModule.startDataRecording(passwordIRDA);

	        /* Uncomment the line below in order to delete data from the Key */
	        //mBTDataKeyModule.startDeleteData();
	    }

	    @Override
	    public void onBTDataKeyOpCodeConfigurationSuccess() {
	    	if (ba.subExists(eventName + "_onbtdatakeyopcodeconfigurationsuccess")) {
	    		BA.Log("lib:Raising.. "+eventName + "_onbtdatakeyopcodeconfigurationsuccess()");								
	    		//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
	    		ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onbtdatakeyopcodeconfigurationsuccess", true, new Object[] {});
	    	}else {
	    		BA.Log("lib: NOTFOUND '"+eventName + "_onbtdatakeyopcodeconfigurationsuccess");
	    	}
	    	// Provide the Password IRDA or null for default ("00000000")
	    	/*byte passwordIRDA[] = new byte[]{1,1,1,1,1,1,1,1};
	        mBTDataKeyModule.startDataRecording(passwordIRDA);*/
	    }

	    @Override
	    public void onBTDataKeyAuditReceived(byte[] raw, String dataKeyMode, String auditText, final String auditPath) {
	    	String str = "";
	    	try {
	    		str = new String(raw, "UTF-8");
	    	} catch (Exception e) {
	    	}
	    	if (ba.subExists(eventName + "_onbtdatakeyauditreceived")) {
	    		BA.Log("lib:Raising.. "+eventName + "_onbtdatakeyauditreceived()");								
	    		//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
	    		ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onbtdatakeyauditreceived", true, new Object[] {raw, dataKeyMode, auditText, auditPath});
	    	}else {
	    		BA.Log("lib: NOTFOUND '"+eventName + "_onbtdatakeyauditreceived");
	    	}

				//	        final AlertDialog.Builder builder = new AlertDialog.Builder(this);
				//
				//	        builder.setMessage("Eva-Dts file succesfully received.\n\nIt has also been saved in:\n\n" + auditPath)
				//	                .setCancelable(false)
				//	                .setPositiveButton(R.string.ok, new DialogInterface.OnClickListener() {
				//	                    @Override
				//	                    public void onClick(DialogInterface dialog, int which) {
				//	                        File file = new File(auditPath);
				//	                        boolean deleted = file.delete();
				//	                        showToast("Cancellato " + deleted);
				//	                        onBackPressed();
				//	                    }
				//	                });
				//
				//	        runOnUiThread(new Runnable() {
				//	            @Override
				//	            public void run() {
				//	                AlertDialog dialog = builder.create();
				//	                dialog.show();
				//	            }
				//	        });
	    }

	    @Override
	    public void onBTDataKeyDeleteSuccess() {
	    	if (ba.subExists(eventName + "_onbtdatakeydeletesuccess")) {
	    		BA.Log("lib:Raising.. "+eventName + "_onbtdatakeydeletesuccess()");								
	    		//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
	    		ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onbtdatakeydeletesuccess", true, new Object[] {});
	    	}else {
	    		BA.Log("lib: NOTFOUND '"+eventName + "_onbtdatakeydeletesuccess");
	    	}
	    }

	    @Override
	    public void onBTDataKeyError(int errorCode) {
	    	String errMsg;
	    	switch (errorCode) {
	    	case BTDataKeyModule.ERR_BTDK_NONE:
	    		return;
	    	case BTDataKeyModule.ERR_BTDK_ILLEGAL_STATUS:
	    		errMsg = "ERR_BTDK_ILLEGAL_STATE";
	    		break;
	    	case BTDataKeyModule.ERR_BTDK_NOT_RESPONDING:
	    		errMsg = "ERR_BTDK_NOT_RESPONDING";
	    		break;
	    	case BTDataKeyModule.ERR_BTDK_DATA_REC_TIMEOUT:
	    		errMsg = "ERR_BTDK_DATA_REC_TIMEOUT";
	    		break;
	    	case BTDataKeyModule.ERR_BTDK_UNLOCKED:
	    		errMsg = "ERR_BTDK_UNLOCKED";
	    		break;
	    	case BTDataKeyModule.ERR_BTDK_OPCODE_SIZE:
	    		errMsg = "ERR_BTDK_OPCODE_SIZE";
	    		break;
	    	case BTDataKeyModule.ERR_BTDK_OPCODE_FORMAT:
	    		errMsg = "ERR_BTDK_OPCODE_FORMAT";
	    		break;
	    	case BTDataKeyModule.ERR_BTDK_OPCODE_UNLOCK_FAIL:
	    		errMsg = "ERR_BTDK_OPCODE_UNLOCK_FAIL";
	    		break;
	    	case BTDataKeyModule.ERR_BTDK_OPCODE:
	    		errMsg = "ERR_BTDK_OPCODE";
	    		break;
	    	case BTDataKeyModule.ERR_BTDK_IRCODE:
	    		errMsg = "ERR_BTDK_IRCODE";
	    		break;
	    	default:
	    		errMsg = String.format("Error Code [%d]",errorCode);
	    	}
	    	if (ba.subExists(eventName + "_onbtdatakeyerror")) {
	    		BA.Log("lib:Raising.. "+eventName + "_onbtdatakeyerror()");								
	    		//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
	    		ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onbtdatakeyerror", true, new Object[] {errorCode, errMsg});
	    	}else {
	    		BA.Log("lib: NOTFOUND '"+eventName + "_onbtdatakeyerror");
	    	}
	    }

	    @Override
	    public void onBTDataKeyModuleError(int errorCode) {
	        String errMsg;
	        switch (errorCode) {
	            case BTDataKeyModule.ERR_NONE:
	                return;
	            case BTDataKeyModule.ERR_BLE_CONNECTION:
	                errMsg = "ERR_BLE_CONNECTION";
	                break;
	            case BTDataKeyModule.ERR_EVA_DATA_WRITE:
	                errMsg = "ERR_EVA_DATA_WRITE";
	                break;
	            case BTDataKeyModule.ERR_INTERRUPTED_PROCESS:
	                errMsg = "ERR_INTERRUPTED_PROCESS";
	                break;
	            default:
	                errMsg = String.format("Error Code [%d]",errorCode);
	        }
		    	if (ba.subExists(eventName + "_onbtdatakeymoduleerror")) {
		    		BA.Log("lib:Raising.. "+eventName + "_onbtdatakeymoduleerror()");								
		    		//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
		    		ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onbtdatakeymoduleerror", true, new Object[] {errorCode, errMsg});
		    	}else {
		    		BA.Log("lib: NOTFOUND '"+eventName + "_onbtdatakeymoduleerror");
		    	}
	    }

	    @Override
	    public void onBTDataKeyStatusChange(int statusCode) {
	    	if (ba.subExists(eventName + "_onbtdatakeystatuschange")) {
	    		BA.Log("lib:Raising.. "+eventName + "_onbtdatakeystatuschange()");								
	    		//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
	    		ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onbtdatakeystatuschange", true, new Object[] {statusCode});
	    	}else {
	    		BA.Log("lib: NOTFOUND '"+eventName + "_onbtdatakeystatuschange");
	    	}

				//	    	switch (statusCode) {
				//	            case BTDataKeyModule.S_DISCONNECTED:
				//
				//	            	if (isJustInited) {
				//	                    this.mBTDataKeyModule.connect(mDevice);
				//	                    isJustInited = false;
				//	                }
				//	                else {
				//	                    showToast("BTDataKey has disconnected!");
				//	                }
				//	                break;
				//	            case BTDataKeyModule.S_READY:
				//	            {
				//	                // This start the DATA recording on BTDataKey
				//	                //  * After successful transmission of Eva-Dts file from BTDataKey to App
				//	                //  * onBTDataKeyAuditReceived() will be called, otherwise either
				//	                //  * onBTDataKeyErr or onBTDataKeyModuleError will be called
				//	                //mBTDataKeyModule.startDataRecording();
				//	                mBTDataKeyModule.getBTDataKeyIDdata();
				//	            }
				//	            break;
				//	        }
	    }

			
			
			

			@Override
	    public void onBTDataKeyIDdataReceived(byte[] raw, String serialNum, String hwId, String hwVer, String productionDate, String fwVersion) {

				final String message = "onBTDataKeyIDdataReceived:\n Serial: " + serialNum +
                "\n HW ID: " + hwId +
                "\n Ver: " + hwVer +
                "\n Manuf. on: " + productionDate +
                "\n FW Ver: BTDataKey v" + fwVersion;
				
				BA.Log(message);
			}
		});
		//getObject()
	}

  public void scanLeDevice(final boolean enable) {
    if (enable) {
    	// Stops scanning after a pre-defined scan period.
    	long scan_period = SCAN_PERIOD;
    	if (mDevAddr != null) {
    		scan_period = SHORT_SCAN_PERIOD;
    	}
    	mHandler.postDelayed(new Runnable() {
    		@SuppressWarnings("deprecation")
				@Override
    		public void run() {
    			if (mDevAddr != null && !mDevAddrFound) {
    				// Return an AlertDialog that informs that the default BLE device has not been found... continue scanning
    				mDevAddr = null;
    				AlertDialog.Builder builder = new AlertDialog.Builder(ba.activity);
    				builder.setMessage("ble_not_found")
    				.setTitle("BLE missing")
    				.setCancelable(false)
    				.setPositiveButton("OK", new DialogInterface.OnClickListener() {
    					@Override
    					public void onClick(DialogInterface dialog, int which) {
    						mHandler.postDelayed(new Runnable() {
    							@Override
    							public void run() {
    								mScanning = false;
    								if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
    									mBluetoothLeScanner.stopScan(mScanCallback);
    								} else {
    									mBluetoothAdapter.stopLeScan(mLeScanCallback);
    								}
    							}
    						}, SCAN_PERIOD);
    					}
    				});
    				AlertDialog alert = builder.create();
    				alert.show();
    			} else {
    				mScanning = false;
    				if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
    					mBluetoothLeScanner.stopScan(mScanCallback);
    				} else {
    					mBluetoothAdapter.stopLeScan(mLeScanCallback);
    				}
    			}
    		}
    	}, scan_period);
    	mScanning = true;
    	if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
    		//ArrayList<ScanFilter> scanFiltList = new ArrayList<>();
    		//scanFiltList.add(new ScanFilter.Builder().setServiceUuid(new ParcelUuid(BluetoothLeService.UUID_COGES_SERVICE)).build());
    		//ScanSettings scanSettings = new ScanSettings.Builder().setScanMode(ScanSettings.SCAN_MODE_LOW_LATENCY).build();
    		//mBluetoothLeScanner.startScan(scanFiltList, scanSettings, mScanCallback);
    		mBluetoothLeScanner.startScan(mScanCallback);
    	} else {
    		mBluetoothAdapter.startLeScan(mLeScanCallback);
    	}
    } else {
    	mScanning = false;
    	if (android.os.Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
    		mBluetoothLeScanner.stopScan(mScanCallback);
    	} else {
    		mBluetoothAdapter.stopLeScan(mLeScanCallback);
    	}
    }
  }

	
	
	public Intent getBTEnableItent(){
		return enableBtIntent;
	}
	public int getBTEnableRequestCode(){
		return BtIntentRequest;
	}
	
	public List getConnectedDevices(int profile){
		java.util.List<BluetoothDevice> list = mBluetoothManager.getConnectedDevices(profile);
		List l = new anywheresoftware.b4a.objects.collections.List();
		l.Initialize();
		for (BluetoothDevice dev : list) {
			l.Add(dev);
		}
		return l;
	}
	public int getConnectionState(int profile, BluetoothDevice device){
		return mBluetoothManager.getConnectionState(device, profile);
	}
	public List getDevicesMatchingConnectionStates(int profile, int[] states){
		java.util.List<BluetoothDevice> list = mBluetoothManager.getDevicesMatchingConnectionStates(profile, states);
		List l = new anywheresoftware.b4a.objects.collections.List();
		l.Initialize();
		for (BluetoothDevice dev : list) {
			l.Add(dev);
		}
		return l;

	}

	//	public List<BluetoothDevice> openGattServer(){
	//		return mBluetoothManager.openGattServer(ba.context, new BluetoothGattServer().{});
	//	}

	public void setBTDataKeyOperatorCode(String opCodeOld, String opCodeNew){
		getObject().setBTDataKeyOperatorCode(opCodeOld, opCodeNew);
	}
	public void sendOpCode(String opCodeOld, String opCodeNew){
		getObject().sendOpCode(opCodeOld, opCodeNew);
	}
	public void SendDataClickListenerClick(byte[] passwordIR){
		getObject().SendDataClickListenerClick(passwordIR);
	}
	public void startDataRecording(byte[] passwordIR){
		getObject().startDataRecording(passwordIR);
	}
	public void startDeleteData(){
		getObject().startDeleteData();
	}
	public String toString(){
		return getObject().toString();
	}
	public void resetStack(){
		getObject().resetStack();
	}
	public void resetCmdReceived(){
		getObject().resetCmdReceived();
	}
	public void resetAck(){
		getObject().resetAck();
	}
	public Boolean getStackReceived(){
		return getObject().isStackReceived();
	}
	public Boolean getStartDdcmpTaskRunning(){
		return getObject().isStartDdcmpTaskRunning();
	}
	public Boolean getSendDdcmpTaskRunning(){
		return getObject().isSendDdcmpTaskRunning();
	}
	public Boolean getCmdReceived(){
		return getObject().isCmdReceived();
	}
	public Boolean getAckReceived(){
		return getObject().isAckReceived();
	}
	public int getStatus(){
		return getObject().getStatus();
	}
	public int getBTDataKeyPendingStatus(){
		return getObject().getBTDataKeyPendingStatus();
	}
	public int getBTDataKeyIDdata(){
		return getObject().getBTDataKeyIDdata();
	}
	public int getBTDataKeyBattLevel(){
		return getObject().getBTDataKeyBattLevel();
	}
	public Boolean getBluetoothLeServiceConnected(){
		return getObject().BluetoothLeServiceIsConnected();
	}
	public void BluetoothLEServiceConnect(String address){
		getObject().BluetoothLeServiceConnect(address);
	}
	public void BluetoothLEServiceDisconnect(){
		getObject().BluetoothLeServiceDisconnect();;
	}
	public void connect(BluetoothDevice aDevice){
		getObject().connect(aDevice);
	}
	public void deinit(){
		getObject().deinit();
	}
	public void disconnect(){
		getObject().disconnect();
	}
	public void enable(){
		mBluetoothAdapter.enable();
		//		mBluetoothAdapter.closeProfileProxy(profile, proxy);
		//		mBluetoothAdapter.getBluetoothLeAdvertiser()
		//		mBluetoothAdapter.getName()
		//		mBluetoothAdapter.getProfileConnectionState(profile)
		//		mBluetoothAdapter.getProfileProxy(context, listener, profile)
		//		mBluetoothAdapter.getRemoteDevice(address)
		//		mBluetoothAdapter.getRemoteDevice(address)
		//		mBluetoothAdapter.getScanMode()
		//		mBluetoothAdapter.getState()
		//		mBluetoothAdapter.listenUsingInsecureRfcommWithServiceRecord(name, uuid)
		//		mBluetoothAdapter.listenUsingRfcommWithServiceRecord(name, uuid)
	}
	public void disable(){
		mBluetoothAdapter.disable();
	}
	public List getBondedDevices(){
		List l = new anywheresoftware.b4a.objects.collections.List();
		l.Initialize();
		Set<BluetoothDevice> devlist = mBluetoothAdapter.getBondedDevices();
		for (BluetoothDevice dev : devlist) {
			l.Add(dev);
		}
		return l;
	}
	public void startLeScan3(){
  	ArrayList<ScanFilter> scanFiltList = new ArrayList<>();
    scanFiltList.add(new ScanFilter.Builder().setServiceUuid(new ParcelUuid(BluetoothLeService.a)).build());
    ScanSettings scanSettings = new ScanSettings.Builder().setScanMode(ScanSettings.SCAN_MODE_LOW_LATENCY).build();
    
    scanner.startScan(scanFiltList, scanSettings, new ScanCallback(){
			@Override
			public void onScanResult(int callbackType, ScanResult result) {
				BA.Log("onScanResult 1 Device");
				BluetoothDevice device = result.getDevice();
	 			if (ba.subExists(eventName + "_onscanresult")) {
  				BA.Log("lib:Raising.. "+eventName + "_onscanresult()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onscanresult", true, new Object[] {AbsObjectWrapper.ConvertToWrapper(new BluetoothDeviceWrapper(), device), callbackType, null});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_onscanresult");
  			}
				
			}
			public void onBatchScanResults(List results) {
				BA.Log("onBatchScanResults "+results.getSize()+" devices");
				for (int i = 0; i < results.getSize(); i++) {
					BluetoothDevice device = (BluetoothDevice) results.Get(i);
				}
			}
			@Override
			public void onScanFailed(int errorCode) { 
				BA.Log("onScanFailed");
				
			}
		});
    
	}
	public void startLeScan2(){
		scanner.startScan(new ScanCallback(){
			@Override
			public void onScanResult(int callbackType, ScanResult result) {
				BA.Log("onScanResult 1 Device");
				BluetoothDevice device = result.getDevice();
	 			if (ba.subExists(eventName + "_onscanresult")) {
  				BA.Log("lib:Raising.. "+eventName + "_onscanresult()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onscanresult", true, new Object[] {AbsObjectWrapper.ConvertToWrapper(new BluetoothDeviceWrapper(), device), callbackType, null});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_onscanresult");
  			}
				
			}
			public void onBatchScanResults(List results) {
				BA.Log("onBatchScanResults "+results.getSize()+" devices");
				for (int i = 0; i < results.getSize(); i++) {
					BluetoothDevice device = (BluetoothDevice) results.Get(i);
				}
			}
			@Override
			public void onScanFailed(int errorCode) { 
				BA.Log("onScanFailed");
				
			}
		});
	}
	public void stopLeScan2(){
		scanner.stopScan(new ScanCallback(){
			@Override
			public void onScanResult(int callbackType, ScanResult result) {
				BA.Log("onScanResult 1 Device");
				BluetoothDevice device = result.getDevice();
	 			if (ba.subExists(eventName + "_onscanresult")) {
  				BA.Log("lib:Raising.. "+eventName + "_onscanresult()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onscanresult", true, new Object[] {AbsObjectWrapper.ConvertToWrapper(new BluetoothDeviceWrapper(), device), callbackType, result.getScanRecord().getBytes()});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_onscanresult");
  			}
				
			}
			public void onBatchScanResults(List results) {
				BA.Log("onBatchScanResults "+results.getSize()+" devices");
				for (int i = 0; i < results.getSize(); i++) {
					BluetoothDevice device = (BluetoothDevice) results.Get(i);
				}
			}
			@Override
			public void onScanFailed(int errorCode) { 
				BA.Log("onScanFailed");
				
			}
		});
	}

	public void stopLeScanADA(){
		mBluetoothAdapter.stopLeScan(new LeScanCallback(){

			@Override
			public void onLeScan(BluetoothDevice Device, int paramInt, byte[] paramArrayOfByte) {
				// TODO Auto-generated method stub
				BA.Log("onLeScan (1 Device)");
	 			if (ba.subExists(eventName + "_onlescan")) {
  				BA.Log("lib:Raising.. "+eventName + "_onlescan()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onlescan", true, new Object[] {AbsObjectWrapper.ConvertToWrapper(new BluetoothDeviceWrapper(), Device), paramInt, paramArrayOfByte});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_onlescan");
  			}

			}});
	}
	
	@SuppressWarnings("deprecation")
	public void startLeScanADA(){
		mBluetoothAdapter.startLeScan(new LeScanCallback(){

			@Override
			public void onLeScan(BluetoothDevice Device, int paramInt, byte[] paramArrayOfByte) {
				// TODO Auto-generated method stub
				BA.Log("onLeScan (1 Device)");
	 			if (ba.subExists(eventName + "_onlescan")) {
  				BA.Log("lib:Raising.. "+eventName + "_onlescan()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onlescan", true, new Object[] {AbsObjectWrapper.ConvertToWrapper(new BluetoothDeviceWrapper(), Device), paramInt, paramArrayOfByte});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_onlescan");
  			}

			}});
	}
	
	public void openGattServer(BA ba){
		mBluetoothManager.openGattServer(ba.context, new BluetoothGattServerCallback(){
			@Override
			public void onConnectionStateChange(BluetoothDevice device, int status, int newState) {
				BA.Log("onConnectionStateChange");
			}
			@Override
			public void onServiceAdded(int status, BluetoothGattService service) {
				BA.Log("onServiceAdded");
				
			}
			@Override
			public void onCharacteristicReadRequest(BluetoothDevice device, int requestId, int offset, BluetoothGattCharacteristic characteristic) { 
				BA.Log("onCharacteristicReadRequest");
				
			}
			@Override
			public void onCharacteristicWriteRequest(BluetoothDevice device, int requestId, BluetoothGattCharacteristic characteristic, boolean preparedWrite, boolean responseNeeded, int offset, byte[] value) { 
				BA.Log("onCharacteristicWriteRequest");
				
			}
			@Override
			public void onDescriptorReadRequest(BluetoothDevice device, int requestId, int offset, BluetoothGattDescriptor descriptor) { 
				BA.Log("onDescriptorReadRequest");
				
			}
			@Override
			public void onDescriptorWriteRequest(BluetoothDevice device, int requestId, BluetoothGattDescriptor descriptor, boolean preparedWrite, boolean responseNeeded, int offset, byte[] value) { 
				BA.Log("onDescriptorWriteRequest");
			}
			@Override
			public void onExecuteWrite(BluetoothDevice device, int requestId, boolean execute) {
				BA.Log("onExecuteWrite");
			}
			@Override
			public void onNotificationSent(BluetoothDevice device, int status) {
				BA.Log("onNotificationSent");
			}
			@Override
			public void onMtuChanged(BluetoothDevice device, int mtu) { 
				BA.Log("onMtuChanged");
			}
			
		});
	}

	public BluetoothDevice getRemoteDevice(String address){
    final BluetoothManager bluetoothManager =
        (BluetoothManager) ba.activity.getSystemService(Context.BLUETOOTH_SERVICE);
    mBluetoothAdapter = bluetoothManager.getAdapter();

    if (mBluetoothAdapter == null) {
      //finish();
    } else if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
    	
    }
    return mBluetoothAdapter.getRemoteDevice(address);
	}	

	public void resume(){
    final BluetoothManager bluetoothManager =
        (BluetoothManager) ba.activity.getSystemService(Context.BLUETOOTH_SERVICE);
    mBluetoothAdapter = bluetoothManager.getAdapter();

    if (mBluetoothAdapter == null) {
      //finish();
    } else if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
    	mLocationManager = (LocationManager) ba.activity.getSystemService( Context.LOCATION_SERVICE );
    	if (mLocationManager == null) {
    	//Toast.makeText(this, R.string.error_location_manager_not_supported, Toast.LENGTH_SHORT).show();
      //finish();
    	}
    }
	}	
	public void test(){
		Intent intent = new Intent(ba.context, ScanDevicesActivity.class);
		intent.putExtra(ScanDevicesActivity.EXTRAS_INTENT_ACTION, ScanDevicesActivity.EXTRAS_DEVICECONTROL_ACTION);
		intent.putExtra(ScanDevicesActivity.EXTRAS_INTENT_SUBACTION, ScanDevicesActivity.EXTRAS_OPCODE_ACTION);
		startActivityDeletePref(intent);
	}

  private void startActivityDeletePref(Intent intent) {
  	mSharedPreferences.edit().remove("NAVACTION").apply();

  	ion = new IOnActivityResult() {

			@Override
			public void ResultArrived(int resultCode, Intent intent) {
				BA.Log("IOnActivityResult:ResultArrived:"+resultCode);
			}

		};
		ba.startActivityForResult(ion, intent);

  
  }
		
}
