package de.donmanfred;

import android.bluetooth.BluetoothDevice;
import android.os.ParcelUuid;
import anywheresoftware.b4a.AbsObjectWrapper;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ShortName;

@ShortName("BluetoothDevice")
//@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE"})
//@Events(values={"onSigned(sign As Object)"})
//@DependsOn(values={"com.android.support:support-v4"})

/**
 * com.android.support:support-v4
 * com.android.support:appcompat-v7
 * com.android.support:cardview-v7
 * com.android.support:gridlayout-v7
 * com.android.support:mediarouter-v7
 * com.android.support:palette-v7
 * com.android.support:recyclerview-v
 * com.android.support:preference-v7
 * com.android.support:support-v13
 * com.google.firebase:firebase-database
 */

public class BluetoothDeviceWrapper extends AbsObjectWrapper<BluetoothDevice>{
	private BA ba;

	public void Initialize(final BA ba, BluetoothDevice device) {
		this.ba = ba;

		final BluetoothDevice _obj = device;
		setObject(_obj);
	}
	public ParcelUuid[] getUuids(){
		return getObject().getUuids();
	}
	public boolean fetchUuidsWithSdp(){
		return getObject().fetchUuidsWithSdp();
	}
	public int getBondState(){
		return getObject().getBondState();
	}
	public String getAddress(){
		return getObject().getAddress();
	}
	public String getName(){
		return getObject().getName();
	}

	
	
		
}
